#include "core/thread/Mutex.hpp"

#include <string.h>

Core::Mutex::Mutex() : mutex() {
    memset(&mutex, 0, sizeof(mutex));
}

Core::Mutex::~Mutex() {
    mtx_destroy(&mutex);
}

CError Core::Mutex::init() {
    return mtx_init(&mutex, mtx_plain) != thrd_success ? ErrorCode::MUTEX_ERROR
                                                       : ErrorCode::NONE;
}

CError Core::Mutex::lock() {
    return mtx_lock(&mutex) != thrd_success ? ErrorCode::MUTEX_ERROR
                                            : ErrorCode::NONE;
}

CError Core::Mutex::unlock() {
    return mtx_unlock(&mutex) != thrd_success ? ErrorCode::MUTEX_ERROR
                                              : ErrorCode::NONE;
}
